Subject: [bug#61461] [PATCH core-updates] gnu: jemalloc: Build with THP support on aarch64.

From: Christopher Baines <[email-masked]>
Date: Thu, 02 Mar 2023 10:05:42 +0000

Roman Scherer <[email-masked]> writes:

> Hello Guix,
>
> I'm running Guix on an aarch64 system that uses a Linux kernel configured with
> a page size of 16K. Some of the substitutes I receive from Guix sometimes do
> not work. I believe all packages that use jemalloc, which are quite a lot.
>
> Rust is one example. It fails like this:
>
> ```
> [roman@bombaclaat guix]$ rustc
> <jemalloc>: Unsupported system page size
> <jemalloc>: Unsupported system page size
> <jemalloc>: Unsupported system page size
> terminate called without an active exception
> Aborted
> ```
>
> Building packages that depend on jemalloc also fail. I can't compile the rust
> package from Guix for example.
>
> This patch series updates jemalloc and enables the use of transparent huge
> pages on the aarch64 architecture. I saw we support THP as well for i686-linux
> and x86_64-linux, so I think it's fine to enable it here as well. At least
> it's better than crashing.
>
> The patch should also make it possible to use substitutes built on CI by
> systems running with larger kernel pages sizes, avoiding long compilation
> times for things like the whole rust toolchain.
>
> Since jemalloc has a lot of dependencies, I think it's a candidate for
> core-updates.
>
> I submitted parts of this patch series in another ticket where I tried to fix
> Icecat compilation on my aarch64 system. But I think it's worth a separate
> issue. And I'm blocked on the other issue at the moment.
>
> Could you please review the patchs?

The patches don't look to apply to core-updates, as far as I can see,
core-updates already has jemalloc 5.3.0 and doesn't pass the
--disable-thp flag for any architecture.